#ifndef DrawDeviceD3D_H
#define DrawDeviceD3D_H

#include <windows.h>
#include <stdio.h>
#include <ddraw.h>
#include <d3d.h>
#include "BasicDrawDevice.h"

/**
 * Irrlicht x[X DrawDevice
 */
class DrawDeviceD3D : public tTVPDrawDevice
{
	typedef tTVPDrawDevice inherited;

protected:
	tjs_int width;        //< [Uw̉ʉ
	tjs_int height;       //< [Uw̉ʏc
	tjs_int destTop;      //< `̈̉
	tjs_int destLeft;     //< `̈̏c
	tjs_int destWidth;    //< `̈̉
	tjs_int destHeight;   //< `̈̏c

	HWND hWnd;
	
	IDirectDraw7 *DirectDraw7;
	IDirect3D7 *Direct3D7;
	IDirect3DDevice7 *Direct3DDevice7;
	IDirectDrawClipper *Clipper;
	IDirectDrawSurface7 *Surface;
	
public:
	// RXgN^
	DrawDeviceD3D(int width, int height);
	// fXgN^
	virtual ~DrawDeviceD3D();

protected:
	// foCX蓖
	void attach(HWND hwnd);

	// foCX
	void detach();
	
	/**
	 * DeviceC}l[W̍W̕ϊs
	 * @param		x		Xʒu
	 * @param		y		Yʒu
	 * @note		x, y  DestRect (0,0) _ƂWƂēnƌȂ
	 */
	void transformToManager(iTVPLayerManager * manager, tjs_int &x, tjs_int &y);

	/** C}l[WDevice̍W̕ϊs
	 * @param		x		Xʒu
	 * @param		y		Yʒu
	 * @note		x, y  C (0,0) _ƂWƂēnƌȂ
	 */
	void transformFromManager(iTVPLayerManager * manager, tjs_int &x, tjs_int &y);

	/**
	 * DeviceWW̕ϊs
	 * @param		x		Xʒu
	 * @param		y		Yʒu
	 * @note		x, y  DestRect (0,0) _ƂWƂēnƌȂ
	 */
	void transformTo(tjs_int &x, tjs_int &y);
	
	/** WWDevice̍W̕ϊs
	 * @param		x		Xʒu
	 * @param		y		Yʒu
	 * @note		x, y  C (0,0) _ƂWƂēnƌȂ
	 */
	void transformFrom(tjs_int &x, tjs_int &y);
	
public:
	//---- LayerManager ̊Ǘ֘A
	virtual void TJS_INTF_METHOD AddLayerManager(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD RemoveLayerManager(iTVPLayerManager * manager);

	//---- `ʒuETCY֘A
	virtual void TJS_INTF_METHOD SetTargetWindow(HWND wnd, bool is_main);
	virtual void TJS_INTF_METHOD SetDestRectangle(const tTVPRect & rect);
	virtual void TJS_INTF_METHOD GetSrcSize(tjs_int &w, tjs_int &h);
	virtual void TJS_INTF_METHOD NotifyLayerResize(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD NotifyLayerImageChange(iTVPLayerManager * manager);

	//---- [U[C^[tF[X֘A
	// window  drawdevice
	virtual void TJS_INTF_METHOD OnMouseDown(tjs_int x, tjs_int y, tTVPMouseButton mb, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnMouseUp(tjs_int x, tjs_int y, tTVPMouseButton mb, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnMouseMove(tjs_int x, tjs_int y, tjs_uint32 flags);
	virtual void TJS_INTF_METHOD OnMouseWheel(tjs_uint32 shift, tjs_int delta, tjs_int x, tjs_int y);

	virtual void TJS_INTF_METHOD GetCursorPos(iTVPLayerManager * manager, tjs_int &x, tjs_int &y);
	virtual void TJS_INTF_METHOD SetCursorPos(iTVPLayerManager * manager, tjs_int x, tjs_int y);
	virtual void TJS_INTF_METHOD RequestInvalidation(const tTVPRect & rect);
	
	//---- ĕ`֘A
	virtual void TJS_INTF_METHOD Show();
	
	//---- LayerManager ̉摜󂯓n֘A
	virtual void TJS_INTF_METHOD StartBitmapCompletion(iTVPLayerManager * manager);
	virtual void TJS_INTF_METHOD NotifyBitmapCompleted(iTVPLayerManager * manager,
		tjs_int x, tjs_int y, const void * bits, const BITMAPINFO * bitmapinfo,
		const tTVPRect &cliprect, tTVPLayerType type, tjs_int opacity);
	virtual void TJS_INTF_METHOD EndBitmapCompletion(iTVPLayerManager * manager);

	// -----------------------------------------------------------------------
	// ŗL\bh
	// -----------------------------------------------------------------------
	
public:
	/**
	 * @return foCX
	 */
	tjs_int64 getDevice() {
		return reinterpret_cast<tjs_int64>((tTVPDrawDevice*)this);
	}

	tjs_int getWidth() {
		return width;
	}
	
	void setWidth(tjs_int width) {
		this->width = width;
		Window->NotifySrcResize();
	}

	tjs_int getHeight() {
		return height;
	}
	
	void setHeight(tjs_int height) {
		this->height = height;
		Window->NotifySrcResize();
	}

	void setSize(tjs_int width, tjs_int height) {
		this->width = width;
		this->height = height;
		Window->NotifySrcResize();
	}

	tjs_int getDestWidth() {
		return destWidth;
	}

	tjs_int getDestHeight() {
		return destHeight;
	}
	
protected:
	/*
	 * vC}C̕W visible
	 */
	bool defaultVisible;

public:
	void setDefaultVisible(bool visible) {
		defaultVisible = visible;
	}
	
	bool getDefaultVisible() {
		return defaultVisible;
	}

	/**
	 * vC}C̕\Ԃ̎w
	 * @param id vC}C̓o^ID
	 * @param visible \
	 */
	void setVisible(int id, bool visible);

	/**
	 * vC}C̕\Ԃ̎w
	 * @param id vC}C̓o^ID
	 * @return visible \
	 */
	bool getVisible(int id);
	
};

#endif
